type NotDone = false;
type Done = true;
export type StatusState = NotDone | Done;
export const StatusState: { done: Done; notDone: NotDone } = {
  done: true,
  notDone: false,
};

export enum Priorities {
  p1 = "p1",
  p2 = "p2",
  p3 = "p3",
}

export interface Todo {
  id: string;
  title: string;
  description?: string;
  status: StatusState;
  project?: string;
  authorId?: string;
  created: number;
  priority?: Priorities;
}

export const asTodo = (item: Todo): Todo => {
  if (!item.id) {
    throw new Error("Validation failed: id is null");
  }

  if (!item.title) {
    throw new Error("Validation failed: title is null");
  }

  if (typeof item.status === "undefined") {
    throw new Error("Validation failed: status is null");
  }

  return item;
};
